#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCIndexPort.h"
#import "QCNumberPort.h"
#import "QCVirtualPort.h"
#import "QCStructurePort.h"

@interface StructureBlend : QCPatch
{
    QCStructurePort	*inputStruct;
	QCNumberPort	*inputIndex;
	QCIndexPort		*inputOrderMode;
	QCIndexPort		*inputWrapMode;
	
    QCVirtualPort	*outputVirtual;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end