#import "StructurePlay.h"


@implementation StructurePlay : QCPatch

+ (int)executionMode
{
	return 2;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}
+ (int)timeMode
{
	return 1;
}


- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	if(z)
	{
		//	0 = play once per gate
		//	1 = loop
		//	2 = ping-pong
		[inputPlayMode setMaxIndexValue:2];
		[inputPlaybackRate setDoubleValue:1.0];
		index = 0.0;
		direction = 0;
	}

	return z;
}


- (id)setup:(QCOpenGLContext *)context
{


	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{


}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{		
	if([inputGate booleanValue] == TRUE)
	{
		QCStructure *structure;
		structure = [inputStruct structureValue];
		
		// if it's gone or empty, bail
		if(structure == nil || [structure count] == 0)
			return YES;
		
		[outputVirtual setRawValue:[structure memberAtIndex:(int)index]];
		
		// upon leaving this switch, index must be a valid number
		switch([inputPlayMode indexValue])
		{
			default:
			case 0:	// one-shot mode
				index += [inputPlaybackRate doubleValue];
				if(index > [structure count]-1)
					index = [structure count] - 1.0;
				else if(index <0.0)
					index = 0.0;
				break;
			case 1:	// loop mode
				index += [inputPlaybackRate doubleValue];
				
				if(index < 0.0)
					index = [structure count] - 1.0;
				if(index > [structure count]-1)
					index = 0.0;
				break;
			case 2: // ping-pong
				if(direction == 0)
					index += [inputPlaybackRate doubleValue];
				else
					index -= [inputPlaybackRate doubleValue];
				
				if(index > [structure count]-1)
				{
					direction ^= 1;
					index = [structure count] - 1.0;
				}
				else if(index <0.0)
				{
					index = 0.0;
					direction ^= 1;
				}
				break;
		}
	}

	return YES;
}

@end
