#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCVirtualPort.h"
#import "QCIndexPort.h"
#import "QCStructurePort.h"
#import "QCStructure.h"

@interface StructureRecordAdv : QCPatch
{
    QCVirtualPort	*inputVirtual;
	QCBooleanPort	*inputGate;
	QCBooleanPort	*inputClear;
	QCBooleanPort	*inputClearOnGate;
	QCBooleanPort	*inputClearWithObject;
	QCIndexPort		*inputMode;
	QCIndexPort		*inputRateDivider;
	QCIndexPort		*inputMaxSamples;
	//QCIndexPort		*inputRecordIn;
	//QCIndexPort		*inputRecordOut;
	
    QCStructurePort	*outputStruct;
	QCIndexPort		*outputIndex;

	// for performance, buffer should eventually become a simple C id* array.
	NSMutableArray	*buffer;
	//NSMutableDictionary	*imageAccumulators;
	QCStructure		*structure;
	unsigned int	index;
	unsigned int	divider;
	BOOL			oldGateValue;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end
