#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCBooleanPort.h"
#import "QCVirtualPort.h"
#import "QCIndexPort.h"
#import "QCStructurePort.h"
#import "QCStructure.h"

#import "StructureRecordAdv.h"

@interface StructureRecordBasic : QCPatch
{
    QCVirtualPort	*inputVirtual;
	QCBooleanPort	*inputGate;
	QCBooleanPort	*inputGateAndClear;
	QCBooleanPort	*inputClear;
	QCIndexPort		*inputMode;
	QCIndexPort		*inputRateDivider;
	QCIndexPort		*inputMaxSamples;
	QCIndexPort		*inputRecordIn;
	QCIndexPort		*inputRecordOut;
	
    QCStructurePort	*outputStruct;
	QCIndexPort		*outputIndex;

	StructureRecordAdv	*recorder;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end
